#!/bin/sh
#Set Paths
PATH=$PATH:/bin:/usr/local/bin:/share/Apps/local/bin:/share/Apps/local/libexec/git-core:/nmt/apps/bin;export PATH
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/lib:opt/syb/app/lib:/nmt/app/lib:/opt/syb/sigma/lib:/usr/local/bin:/share/Apps/local/lib;export LD_LIBRARY_PATH
MANPATH=$MANPATH:/usr/local/share/man:/share/Apps/local/share/man;export MANPATH

LOCAL=/share/Apps/local
OPKG=$LOCAL/bin/opkg

install()
{
    if [ -d /opt/gaya ]; then
        MODEL=a110
	else
		CHIPSET=`/opt/syb/sigma/bin/gbus_read_uint32 0x0002fee8 2>&-`
		if [ $CHIPSET = "0x00008911" ];then
            MODEL=a400
		elif [ $CHIPSET = "0x00008647" -o $CHIPSET = "0x00008643" ];then
            MODEL=c200
		fi
    fi

    # Check opkg installation
    if [ ! -f $OPKG ]; then
        echo "Required dependency, opkg (local) is not installed, Forcing install"
        cd /share
        wget -q http://sourceforge.net/projects/nmtcsi/files/opkg_${MODEL}_latest.zip
        unzip opkg_${MODEL}_latest.zip
        if [ -f opkg.tar ];then
            /share/Apps/AppInit/appinit.cgi install opkg.tar
            rm opkg.tar opkg_${MODEL}_latest.zip
        fi
    else
        echo "Required dependency, opkg (local) is installed."
    fi

	$OPKG update
	
    # install python2.7
    if [ -f /share/Apps/local/bin/python2.7 ]; then
    	echo "Required dependency, python is installed."
    else
    	echo "Installing dependency, python2.7"
    	$OPKG install python2.7 --force-depends --force-overwrite --force-reinstall
    fi
	
    # install expat
    if [ -f /share/Apps/local/lib/python2.7/xml/parsers/expat.py ]; then
    	echo "Required dependency, expat is installed."
    else
    	echo "Installing dependency, expat"
    	$OPKG install expat --force-depends --force-overwrite --force-reinstall
    fi
	
	# install git
    if [ -f /share/Apps/local/bin/git ]; then
    	echo "Required dependency, git is installed."
    else
    	echo "Installing dependency, git"
    	$OPKG install git --force-depends --force-overwrite --force-reinstall
    fi
	
    # install coreutils
    if [ -f /share/Apps/local/bin/tr ]; then
    	echo "Required dependency, coreutils is installed."
    else
    	echo "Installing dependency, coreutils"
    	$OPKG install coreutils --force-depends --force-overwrite --force-reinstall
    fi
	
	# install start-stop-daemon
    if [ -f /share/Apps/local/sbin/start-stop-daemon ]; then
    	echo "Required dependency, start-stop-daemon is installed."
    else
    	echo "Installing dependency, start-stop-daemon"
    	$OPKG install start-stop-daemon --force-depends --force-overwrite --force-reinstall
    fi
	
	#install Cheetah
    #if [ -d /share/Apps/local/lib/python2.7/site-packages/Cheetah ] ; then     
	#    echo "Cheetah is installed"
    #else
	#    cd /share/Apps/CouchpotatoV2/
	#    wget http://pypi.python.org/packages/source/C/Cheetah/Cheetah-2.4.4.tar.gz --no-check-certificate
	#    tar -zxvf Cheetah-2.4.4.tar.gz
	#    cd Cheetah-2.4.4
	#    /share/Apps/local/bin/python2.7 setup.py install
    #fi

    # install CouchPotatoServer
    if [ -f /share/Apps/CouchpotatoV2/main/CouchPotato.py ] ; then     
	    echo "couchpotato2 is installed"
    else
    	rm -r /share/tmp
    	chmod -R 777 /share/Apps/CouchpotatoV2
    	mkdir /share/tmp
    	cd /share/tmp
    	/share/Apps/local/bin/git clone git://github.com/RuudBurger/CouchPotatoServer.git CP
    	cp -Ra CP/. /share/Apps/CouchpotatoV2/main
    	chmod -R 777 /share/Apps/CouchpotatoV2
    	cd
    	rm -r /share/tmp
    fi
 
    # make settings folder
    if [ -d /share/Apps/CouchpotatoV2/data ]; then
    	echo "No need to make settings folder"
    elif [ -d /share/Apps/CP_Settings ]; then
    	echo "Moving your old settings folder"
    	mv /share/Apps/CP_Settings /share/Apps/CouchpotatoV2/data
    	a='data_dir = \/share\/Apps\/CP_Settings'
    	b='data_dir = \/share\/Apps\/CouchpotatoV2\/data'
    	sed -i "s/$a/$b/g" /share/Apps/CouchpotatoV2/data/settings.conf
    	rm /share/Apps/CouchpotatoV2/main/default.settings.conf
    else
    	mkdir -p /share/Apps/CouchpotatoV2/data
    	if [ -f /share/Apps/CouchpotatoV2/main/settings.conf ] ; then
    		echo "Copying users settings"
    		mv /share/Apps/CouchpotatoV2/main/settings.conf /share/Apps/CouchpotatoV2/data/settings.conf
	    	rm /share/Apps/CouchpotatoV2/main/default.settings.conf
		    sed -i 's/CouchpotatoV2/data/g' /share/Apps/CouchpotatoV2/data/settings.conf
    		mv /share/Apps/CouchpotatoV2/main/couchpotato.db /share/Apps/CouchpotatoV2/data/couchpotato.db
	    	mv /share/Apps/CouchpotatoV2/main/cache /share/Apps/CouchpotatoV2/data/cache
		    mv /share/Apps/CouchpotatoV2/main/db_backup /share/Apps/CouchpotatoV2/data/db_backup
    		mv /share/Apps/CouchpotatoV2/main/logs /share/Apps/CouchpotatoV2/data/logs 
	    else
		    echo "Copying default settings"
    		mv /share/Apps/CouchpotatoV2/default.settings.conf /share/Apps/CouchpotatoV2/data/settings.conf
	    fi
    fi

	$OPKG upgrade
}

uninstall()
{
    if [ -d /share/Apps/CouchpotatoV2 ]; then
		rm -R /share/Apps/CouchpotatoV2
    fi
}


case "$1" in
    install)
    install
    ;;
    
    uninstall)
    uninstall
    ;;
esac